unit MergeWizard;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, Menus, MailMerg;

type
  TWizardMailMergeDlg = class(TForm)
    Bevel1: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Bevel4: TBevel;
    MailMergeBtn: TButton;
    MailMergeType: TLabel;
    MainDocText: TLabel;
    DBText: TLabel;
    Label9: TLabel;
    lbSuppressBlankLines: TLabel;
    lbMailMergeToWhere: TLabel;
    Fermer: TButton;
    OpenDialog: TOpenDialog;
    OpenBtn: TBitBtn;
    DSBtn: TBitBtn;
    MainDocPopupMenu: TPopupMenu;
    FormLettersItem: TMenuItem;
    MailingLabelsItem: TMenuItem;
    EnvelopesItem: TMenuItem;
    CatalogItem: TMenuItem;
    LineHelp: TLabel;
    Line2Help: TLabel;
    DSPopupMenu: TPopupMenu;
    DSOpenItem: TMenuItem;
    MailMerge: TMailMerge;
    TBText: TLabel;
    procedure OpenBtnClick(Sender: TObject);
    procedure DSBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure DSOpenItemClick(Sender: TObject);
    procedure FormLettersItemClick(Sender: TObject);
    procedure MailingLabelsItemClick(Sender: TObject);
    procedure EnvelopesItemClick(Sender: TObject);
    procedure CatalogItemClick(Sender: TObject);
    procedure MailMergeBtnClick(Sender: TObject);
    procedure FermerClick(Sender: TObject);
  private
    { Dclarations prives }
    procedure EnableButtons(Sender: TObject);
    procedure SetMailMergeType(Sender: TObject);
    procedure SetMaindocumentName(AFileName: TFileName);
    procedure SetDatabaseName(AFileName: TFileName);
    procedure SetTableName(AFileName: TFileName);

    function OpenTemplate(Sender: TObject): TFileName;
  public
    { Dclarations publiques }
  end;

var
  WizardMailMergeDlg: TWizardMailMergeDlg;

implementation

{$R *.DFM}

uses MergeParams, OpenDS, OpenTabl;

procedure TWizardMailMergeDlg.OpenBtnClick(Sender: TObject);
var
  X, Y: Integer;
begin
  X:=Left+OpenBtn.Left+2;
  Y:=Top+OpenBtn.Top+OpenBtn.Height+21;
  MainDocPopupMenu.Popup(X, Y);
end;

procedure TWizardMailMergeDlg.DSBtnClick(Sender: TObject);
var
  X, Y: Integer;
begin
  X:=Left+OpenBtn.Left+2;
  Y:=Top+DSBtn.Top+DSBtn.Height+21;
  DSPopupMenu.Popup(X, Y);
end;

procedure TWizardMailMergeDlg.FormShow(Sender: TObject);
begin
  SetMailMergeType(Self);
  SetMaindocumentName('');
  SetDatabaseName('');
  SetTableName('');
  EnableButtons(Self);
  OpenBtn.SetFocus;
end;

procedure TWizardMailMergeDlg.DSOpenItemClick(Sender: TObject);
begin
  with OpenDialog do
  begin
    Title:='Source de donnes';
    FileName:='';
    Filter:='Fichiers texte (*.txt)|*.txt|Bases de donnes Access (*.mdb)|*.mdb';
    if Execute then
    begin
      if UpperCase(ExtractFileExt(FileName)) = '.MDB' then
      begin
        if OpenTableDlg.ShowModal = mrOk then
        begin
          SetDatabaseName(FileName);
          SetTableName(OpenTableDlg.TableName.Text);
        end;
      end
      else
      begin
        if OpenDSDlg.ShowModal = mrOk then
        begin
          with OpenDSDlg.AliasNames do SetDatabaseName(Items[ItemIndex]);
          SetTableName(FileName);
        end;
      end;
    end;
    EnableButtons(Self);
  end;
end;

function TWizardMailMergeDlg.OpenTemplate(Sender: TObject): TFileName;
begin
  with OpenDialog do
  begin
    Title:='Document principal';
    FileName:='';
    Filter:='Documents Word (*.doc)|*.doc|Modles Word (*.dot)|*.dot';
    if Execute then SetMaindocumentName(FileName);
    EnableButtons(Self);
    Result:=FileName;
  end;
end;

procedure TWizardMailMergeDlg.FormLettersItemClick(Sender: TObject);
begin
  MailMerge.DocumentType:=dtFormLetters;
  SetMailMergeType(Self);
  OpenTemplate(Self);
end;

procedure TWizardMailMergeDlg.MailingLabelsItemClick(Sender: TObject);
begin
  MailMerge.DocumentType:=dtMailingLabels;
  SetMailMergeType(Self);
  OpenTemplate(Self);
end;

procedure TWizardMailMergeDlg.EnvelopesItemClick(Sender: TObject);
begin
  MailMerge.DocumentType:=dtEnvelopes;
  SetMailMergeType(Self);
  OpenTemplate(Self);
end;

procedure TWizardMailMergeDlg.CatalogItemClick(Sender: TObject);
begin
  MailMerge.DocumentType:=dtCatalog;
  SetMailMergeType(Self);
  OpenTemplate(Self);
end;

procedure TWizardMailMergeDlg.SetMailMergeType(Sender: TObject);
begin
  MailMergeType.Caption:='Type de fusion: ';
  case MailMerge.DocumentType of
    dtFormLetters: MailMergeType.Caption:=MailMergeType.Caption+'Lettres types';
    dtMailingLabels: MailMergeType.Caption:=MailMergeType.Caption+'Etiquettes de publipostage';
    dtEnvelopes: MailMergeType.Caption:=MailMergeType.Caption+'Enveloppes';
    dtCatalog: MailMergeType.Caption:=MailMergeType.Caption+'Catalogues';
  end;
end;

procedure TWizardMailMergeDlg.SetMaindocumentName(AFileName: TFileName);
begin
  MailMerge.DocumentName:=AFileName;
  MainDocText.Caption:='Document principal: '+ExtractFileName(AFileName);
end;

procedure TWizardMailMergeDlg.SetDatabaseName(AFileName: TFileName);
begin
  MailMerge.DatabaseName:=AFileName;
  DBText.Caption:='Base de donnes: '+AFileName;
end;

procedure TWizardMailMergeDlg.SetTableName(AFileName: TFileName);
begin
  MailMerge.TableName:=AFileName;
  TBText.Caption:='Table: '+AFileName;
end;

procedure TWizardMailMergeDlg.EnableButtons(Sender: TObject);
begin
  DSBtn.Enabled:=MailMerge.DocumentName <> '';
  MailMergeBtn.Enabled:=(MailMerge.DocumentName <> '') and
                        (MailMerge.DatabaseName <> '') and
                        (MailMerge.TableName <> '');
  if MailMerge.DocumentName = '' then
  begin
    LineHelp.Caption:='Cette liste vous aide  oprer une fusion.';
    Line2Help.Caption:='Commencer avec le bouton Crer.';
  end
  else if (MailMerge.DatabaseName = '') or (MailMerge.TableName = '') then
  begin
    LineHelp.Caption:='L''tape suivante consiste  ouvrir un fichier de donnes.';
    Line2Help.Caption:='Cliquez sur Obtenir des donnes.';
  end
  else
  begin
    LineHelp.Caption:='Le document principal et la source de donnes sont prts pour la fusion.';
    Line2Help.Caption:='Cliquez sur Fusionner.';
  end;
end;

procedure TWizardMailMergeDlg.MailMergeBtnClick(Sender: TObject);
begin
  if MergeParamsDlg.ShowModal = mrOK then MailMerge.Execute;
end;

procedure TWizardMailMergeDlg.FermerClick(Sender: TObject);
begin
  Close;
end;

end.
